/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var helpstr = "In general, this plugin operates on the parameters of the webpage you are curriently browsing and predefined parameters in ConQuery Config Dialog. When you execute ConQuery menu entry, the engine substitutes user variables in predefined URL template with corresponding page data. Available variables are: \n [:selection] - selected text;\n [:url] - page URL;\n [:host] - only HOST from page URL;\n [:prompt] - prompt for input text.\n You may combine variables in template. If there is [:selection] and no selected text on a page, the ConQuery will ask you to input one. You may also tune up query before execution: hold Ctrl key while executing menu entry.\n    All queries organized in two groups: \n - list in ''ConQuery Config'' dialog under the My ConQueries tab;\n - entries under the ''Query to...'' context menu item.\n You may execute queries from bouth places. All manipulations with entries in Config menu performs with mouse right-click. The property ''Show?'' indicates whether query is shown in context menu group.\n The Config Dialog is also accessible via doubleclick on ''Query to...'' browser context menu entry.\n Note that this is alpha version, so any suggestions will be appreciated.\n Happy serfing!\n McV.";
var EntryList;
var EntryDesc;
var repEntryList;
var delim = "\\";
var ShowAlternatives = false;
var ShowBlocked = false;
var cancel = false;

function init(){
  EntryList    = document.getElementById('EntryList');
  EntryDesc    = document.getElementById('Desc');
  repEntryList = document.getElementById('repEntryList');
	repEntryDesc = document.getElementById('repDesc');
	PlugsDirBox  = document.getElementById('plugsdir');
	ReadOnlyCqr  = document.getElementById('cqonly');
	ShowBlocked  = document.getElementById('showblocked').checked;
	//PlugsDirBox.value = GetMycroftDir();
	//document.getElementById('help').value = helpstr;
  
  ////moved to main.js
  //prfs_LoadMain();
  
	plg_QuickLoadAll();
  prfs_UpdateEntries();

	window.setTimeout('initWithDelay();', 0);
  //window.sizeToContent();
}

function plg_ReloadTree(){
	plg_QuickLoadAll();
  prfs_UpdateEntries();
  initList(EntryList, EntryHash);
}

function plg_block(really){
  if (!EntryList.selectedItem) return;
  EntryHash[EntryList.selectedItem.getAttribute('value')].blocked = really;
  prfs_SaveEntries();
  plg_ReloadTree();
}

function initWithDelay(){
  fillprefstab();
  initList(EntryList, EntryHash);
}

function fillprefstab() {
	document.getElementById('prfs_plugsdir').value = PlugsDir;
	document.getElementById('enhotmenu').checked = UseHotMenu;
	document.getElementById('loadinbg').checked = LoadTabsInBg;
}



function initList(list, srcHash){
  ShowBlocked  = document.getElementById('showblocked').checked;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var cellcheck;
  var entries = srcHash._Items();

  var listcols =  document.createElement('listcols');
  var listcol1 =  document.createElement('listcol');
  var listcol2 =  document.createElement('listcol');
  var listcol3 =  document.createElement('listcol');
  var splitter = document.createElement('splitter');
  var listhead = document.createElement('listhead');
  var listheader1 =  document.createElement('listheader');
  var listheader2 =  document.createElement('listheader');
  var listheader3 =  document.createElement('listheader');
  splitter.setAttribute("class", "tree-splitter");
  listcol1.setAttribute("flex", "16");
  listcol2.setAttribute("flex", "1");
  listcol2.setAttribute("style", "width: 4em;");
  listcol3.setAttribute("flex", "1");
  listcol3.setAttribute("style", "width: 5em;");
  listcols.appendChild(listcol1);
    if (srcHash == EntryHash){
      listcols.appendChild(splitter);
      listcols.appendChild(listcol2);
      listcols.appendChild(listcol3);
    }
  listheader1.setAttribute('label', "Queries");
  listheader2.setAttribute('label', "Show?");
  listheader3.setAttribute('label', "Show if?");
  listhead.appendChild(listheader1);
    if (srcHash == EntryHash){
      listhead.appendChild(listheader2);
      listhead.appendChild(listheader3);
    }
  list.appendChild(listcols);
  list.appendChild(listhead);
  
  for (i=0; i<entries.length; i++){
		if ((!ShowBlocked) && (entries[i].blocked)) continue;
			  if (list.id == "EntryList"){
			  	ondk  = 'if (isValidLeftClick(event,"listitem")) ExecQuery(event.ctrlKey, "'+entries[i].eId+'");';
			  	onsel = 'onSelect(EntryHash, EntryDesc, '+entries[i].eId+')'
			  } else if(list.id == "repEntryList"){
			  	ondk='if (isValidLeftClick(event,"listcell")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
			  	onsel = 'onSelect(repEntryHash, repEntryDesc, '+entries[i].eId+')';
			  }

    item = document.createElement('listitem');
    item.setAttribute('value', entries[i].eId);
    item.setAttribute('allowevents', true);
    //if (entries[i].showif) item.setAttribute('style', "color: #408080");
    if (entries[i].blocked) item.setAttribute('style', "color: #828282");
		//item.setAttribute('ondblclick', ondk);
		
    celldata = document.createElement('listcell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('ondblclick', ondk);
    item.appendChild(celldata);
    if (srcHash == EntryHash){
      cellcheck = document.createElement('listcell');
      check = document.createElement('checkbox');
      check.setAttribute('id', entries[i].eId);
      check.setAttribute('oncommand', "UpdateStatus(this);");
      check.setAttribute('checked', entries[i].Context);
      cellcheck.appendChild(check);
      item.appendChild(cellcheck);
      if (entries[i].showif){
        cellshowif = document.createElement('listcell');
        cellshowif.setAttribute('label', "yes");
        item.appendChild(cellshowif);
      }
    }
    list.appendChild(item);
  }
}

function FetchPrefs(){
try{
  //EntryHash._Clear();
  var entries = new Object();
  //var entry = new ProtoEntry();
  var prfs = Prefs.getChildList("Entries.", {value: 0});
    for (p in prfs){
      tmp = prfs[p].split(".");
      entries[tmp[1]] = "";
    }
  for (it in entries){
    entry = new ProtoEntry();
    entry.eId = ReadPref("Entries."+it+".eId");
    entry.Title = ReadPref("Entries."+it+".Title");
    entry.Method = ReadPref("Entries."+it+".Method");
    entry.Desc = ReadPref("Entries."+it+".Desc");
    entry.Context = ReadPref("Entries."+it+".Context");
    entry.showif = ReadPref("Entries."+it+".showif");
    //entry.haslist = ReadPref("Entries."+it+".haslist");
    entry.filepath = ReadPref("Entries."+it+".filepath");
    EntryHash._AddEntryObj(entry, entry.eId);
  }
}catch(er){cqerr(er, "FetchPrefs sub")}
}

function ReadPref(name){
	if (Prefs.prefHasUserValue(name)) {
	var type = Prefs.getPrefType(name);
    if (type & 128) {
      return Prefs.getBoolPref(name);
    }
    else if (type & 32) {
			return Prefs.getCharPref(name);
    }
		else {
			return "";
		}
	} else {return ""}
}

function SavePrefs(){
try{
  Prefs.deleteBranch("Entries.");
  var entries = EntryHash._Items();
  for (e in entries){
    Prefs.setCharPref("Entries."+entries[e].eId+".eId", entries[e].eId);
    Prefs.setCharPref("Entries."+entries[e].eId+".Title", entries[e].Title);
    //Prefs.setCharPref("Entries."+entries[e].eId+".Method", entries[e].Method);
    //Prefs.setCharPref("Entries."+entries[e].eId+".Desc", entries[e].Desc);
    Prefs.setCharPref("Entries."+entries[e].eId+".filepath", entries[e].filepath);
    Prefs.setBoolPref("Entries."+entries[e].eId+".Context", entries[e].Context);
    Prefs.setCharPref("Entries."+entries[e].eId+".showif", entries[e].showif);
    //Prefs.setBoolPref("Entries."+entries[e].eId+".haslist", entries[e].haslist);
	}
}catch(er){cqerr(er, "SavePrefs sub")}
}

/*
function LoadRepository(src){
  if (!src) src = document.getElementById('repsrc').label;
	repEntryHash._Clear();
	try{
		xmlDoc = GetXMLFromWeb(src);
		//pNode = xmlDoc.getElementsByTagName("conquery")[0].getElementsByTagName("entry")[0].getElementsByTagName("title")[0].firstChild.data;//.nodeName
		pNode = xmlDoc.getElementsByTagName("conquery")[0].getElementsByTagName("entry");
		for (i=0; i<pNode.length; i++){
	    repEntryHash._Add(
	      "",
	      ParseNode(pNode[i], "title"),
	      ParseNode(pNode[i], "url"),
	      ParseNode(pNode[i], "method"),
	      ParseNode(pNode[i], "desc"),
	      ""
	    )
		}
	}
	catch(er){cqerr(er, "LoadRepository sub")}
	//initList(repEntryList, repEntryHash);
	initRepTree(repEntryList, repEntryHash);
}

function ParseNode(node, child){
	try{return node.getElementsByTagName(child)[0].firstChild.data;}
	catch(er){return "";}
}

function GetXMLFromWeb(uri) {
	try{
		var xrequest = new XMLHttpRequest();
		xrequest.open("GET",uri,false);
		xrequest.setRequestHeader('Content-type', 'text/xml');
		xrequest.send(null);
	}catch(er){cqerr(er, "GetXMLFromWeb sub")}
	return xrequest.responseXML;
}
*/

function CopyFromRep(){
try{
  var item = new ProtoEntry();
	var RepId = repEntryList.contentView.getItemAtIndex(repEntryList.currentIndex).id;
 
  //item = repEntryHash._Item(RepId)._Clone();
  EntryHash._AddEntryObj(repEntryHash._Item(RepId), "");
  //window.opener.top.EntryHash._AddEntryObj(repEntryHash._Item(RepId), "");
	SavePrefs();
	initList(EntryList, EntryHash);
	alert("''"+repEntryHash._Item(RepId).Title + "'' installed");
}catch(er){cqerr(er, "CopyFromRep sub")}
}


function ReadPluginData(filepath){
  var retItem = new ProtoEntry();
  var haslist = false;
  //retItem = new Object;
	filedata = cqReadFile(filepath);
	filedata = filedata.replace(/#.*/ig,"");
	filedata = filedata.replace(/[\n\r\f\t]/ig,"  ");
	SearchTagData = filedata.match(/<search.+?<\/search>/gi);
	mcSearch = GetTagsFromString("search", SearchTagData);
	//mcSearch = GetTagsFromString("search", filedata);
	if (mcSearch[0]){
		var act = "";
		var amp = "";
		retItem.Title = mcSearch[0].name;
		retItem.Action = mcSearch[0].action;
		retItem.Method = mcSearch[0].method;
		retItem.Desc = mcSearch[0].description;
		retItem.qcharset = mcSearch[0].querycharset;
		retItem.showif = mcSearch[0].showif;
		var inp = GetTagsFromString("input", SearchTagData);
		//exploreobj(inp);
		for (each in inp){
			//retItem.Inputs[inp[each].priority] = inp[each];
			haslist = retItem._StoreInput(inp[each]);
      if (!retItem.haslist) retItem.haslist = haslist;
		}
		if ((!retItem.Title) || (retItem.Title=="undefined")) {
		  retItem.Title = "zzzz!!! PARSEERROR: "+filepath;
		  retItem.Desc = filepath + " has no <search> tag or <search> tag not well formed!";
		}
		if ((!retItem.Method) || (retItem.Method=="undefined")) retItem.Method = "GET";
		if ((!retItem.qcharset) || (retItem.qcharset=="undefined")) retItem.qcharset = "UTF-8";
		if ((!retItem.showif) || (retItem.showif=="undefined")) retItem.showif = "";
		if ((!retItem.Desc) || (retItem.Desc=="undefined")) retItem.Desc = "";
		retItem.eId = "";
		retItem.filepath = filepath;
		retItem.Context = true;
	}else{
	  	retItem.eId = "";
	  	retItem.Title = "zzzz!!! PARSEERROR: "+filepath;
	  	retItem.Method = "GET";
	  	retItem.Desc = filepath + " has no <search> tag or <search> tag not well formed!";
	  	retItem.Context = "";
	  	retItem.FilePath = filepath;
	}
  return retItem;	
}

function GetTagsFromString(tag, str){
	//This extracts all <tag param=value> patterns from str
	//WARNING! It sucks on patterns like <tag param="from > to"> extracting only <tag param="from >
	var lcTagsData = [];
	var lcTagsBuff = [];
	//var lcTagsRE = new RegExp("<"+tag+" .+?>","i");
	var lcTagsRE = new RegExp("(<"+tag+" .[^<]+?>)","ig");
	//var lcTagsRE = new RegExp("<"+tag+" (.[^<]+?)>","ig");
	while (lcTagsBuff!=null){
	  lcTagsBuff = lcTagsRE.exec(str);
	  if (lcTagsBuff!=null){
			lcTagsData[lcTagsData.length]=ParseTagParams(lcTagsBuff[0]);
			lcTagsData[lcTagsData.length-1].priority = lcTagsRE.lastIndex;
	  }
	}
return lcTagsData;
}

function ParseTagParams(tag){
  var lcParams = new Object;
	var lcParamsBuff = "  ";
  var lcParamsData = [];
  //To correct Mycroft's "user" in <input>.
  //To plugin coders:
  //   Guys, please, no <input name="blah" user=""> and unclosed <search> tags!
  //   Read Mycroft spec! Such inputs will have value="!!!PARSEERROR!!!"
  tag = String(tag).replace(/\s+?user(?=\s*[\/>])/i, " value="+String.fromCharCode(34)+"[:selection]"+String.fromCharCode(34));
	lcParams["value"]="!!!PARSEERROR!!!";
	//This will understand only <"> but not <'> as pattern, sorry :(
  var ParamsRE = new RegExp("\\w+\\s*?=\\s*?"+String.fromCharCode(34)+".*?"+String.fromCharCode(34),"ig");
  //var ParamsRE = new RegExp("\\w+?\\s*?=\\s*?\\w+?(?=[\\s\\/>])","ig");
  while (lcParamsBuff){
		//lcParamsBuff = String(tag).match(/\w+\s*?=\s*?".*?"/i);
		lcParamsBuff = ParamsRE.exec(tag);
		if (lcParamsBuff!=null){
			lcParamsArr = String(lcParamsBuff[0]).split(/=\s*"/);
			lcParamsArr[1] = lcParamsArr[1].replace(/^\s+/, "");
			lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] = lcParamsArr[1].replace(/"\s*/, "");
			//tag = String(tag).replace(lcParamsBuff, "");
		}
	}
  //for not parenthesized params (i.e. param=value)
//  lcParamsBuff = "  ";
//  
//  while (lcParamsBuff){
//		lcParamsBuff = String(tag).match(/\w+?\s*?=\s*?\w+?(?=[\s\/>])/i);
//		if (lcParamsBuff){
//			lcParamsArr = String(lcParamsBuff).split(/=/);
//			lcParamsArr[1] = lcParamsArr[1].replace(/^\s+/, "");
//			lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] = lcParamsArr[1].replace(/\s+$/, "");
//			tag = String(tag).replace(lcParamsBuff, "");
//		}
//	}
//explorearr(lcParams);
return lcParams;
}


function initRepTree(list, srcHash){
//window.setTimeout('setstatus("Buidling tree...")',7000);
  var cnt = 0;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var entries = srcHash._Items();
	var treecols = document.createElement('treecols');
	var treecol = document.createElement('treecol');
  treecol.setAttribute("label", "Found plugins");
  treecol.setAttribute("flex", "1");
  treecol.setAttribute("id", "www");
	treecols.appendChild(treecol);
	list.appendChild(treecols);
	var tch = document.createElement('treechildren');
	//list.appendChild(tch);
  list.setAttribute('allowevents', false);
  for (i in entries){
  	ondk='if (isValidLeftClick(event,"listitem")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
  	onsel = 'onSelectRep('+entries[i].eId+')';
    item = document.createElement('treeitem');
    item.setAttribute('id', entries[i].eId);
    row = document.createElement('treerow');
    
    row.setAttribute('id', entries[i].eId);
    celldata = document.createElement('treecell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('onselect', onsel);
    row.appendChild(celldata);
    
    item.appendChild(row);
    tch.appendChild(item);
  }
  list.appendChild(tch);
}

function rmEntry()
{
  if (!EntryList.selectedItem) return;
  EntryHash._Rm(EntryList.selectedItem.getAttribute('value'));
  SavePrefs();
  initList(EntryList, EntryHash);
}

function onSelect(){
	var desctext = "";
	eId = EntryList.selectedItem.getAttribute('value');
	item = EntryHash._Item(eId);
	desctext = item.Title + ":\n" +
  	item.Desc + "\n" +
  	item.filepath;
	if (item.showif) desctext += "\nWill be shown if: " + item.showif;
	if (item.haslist) desctext += "\n\n This query has additional parameters. Hold Ctrl while executing menu entry to configure";
	EntryDesc.value = desctext;
}

function onSelectRep(eId){
	if (!eId) eId = repEntryList.contentView.getItemAtIndex(repEntryList.currentIndex).id;
	item = repEntryHash._Item(eId);
	desctext = item.Title + ":\n" +
  	item.Desc + "\n" +
  	item.filepath;
	desctext += "\n------------------------------------\nQuery has following Inputs:\n";
  for (i in item.Inputs){
    desctext += i+" = "+item.Inputs[i].value +"\n";
    if (item.Inputs[i].list){
    	for (v in item.Inputs[i].list) desctext += "   or: "+item.Inputs[i].list[v].value + "\n";
    }
  }
  repEntryDesc.value = desctext;
}

function UpdateStatus(check){
  EntryHash[check.id].Context = check.checked;
	prfs_SaveEntries();
}

function ImportPlugins(){
	//if (!item) item=EntryList.selectedItem.getAttribute('value');
	//if (item=="add") item="";
	repEntryHash._Clear();
	window.openDialog("chrome://conquery/content/mcparser.xul","_blank",
	"centerscreen,chrome,modal,resizable=yes", document.getElementById("plugtype").selectedItem.id);
}

function AddUpdate(item){
	if (!item) item=EntryList.selectedItem.getAttribute('value');
	if (item=="add") item="";
	window.openDialog("chrome://conquery/content/addupdate.xul","_blank",
	"centerscreen,chrome,modal,resizable=yes", item);
	SavePrefs();
	initList(EntryList, EntryHash);
}

function ExecQuery(ctrl, id){
try{
  window.opener.top.ConfigLastWillId = EntryList.selectedItem.getAttribute('value');
  window.opener.top.ConfigLastWillCtrl = ctrl;
  window.close();
}catch(er){cqerr(er, "ExecQuery sub")}
}


function isValidLeftClick(aEvent, aName){
  return (aEvent.button == 0 && aEvent.originalTarget.localName == aName);
}
