/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var PageSelection = "";
var PageURL = "";
var PageHost = "";
var LinkURL = "";
var ConfigLastWillId = "";
var ConfigLastWillCtrl = false;

/// HotMenu. Many thanks to Henrik Gulbrandsen for developing this!
function RegisterContextMenuListener(){
  getBrowser().addEventListener("contextmenu", HandleContextMenu, true);
}

function HandleInsertedNode(event){
// somehow this sub breaks up the top menu ("File", "Edit" e.t.c) of Mozilla 1.7a, bild 2004010508
// ...and somehow HotMenu works without this :))
//  if (event.target.id == "content"){
//    RegisterContextMenuListener();
//  } 
}

document.addEventListener("DOMNodeInserted", HandleInsertedNode, false);
RegisterContextMenuListener();

function HandleContextMenu(event){
  //[:linkurl] Thanks Biju G C for idea and pointing me to findParentNode()
  LinkURL = findParentNode(event.originalTarget, "a");
  
  Shift = event.shiftKey;
  prfs_LoadMain();
  if ((Shift == true) && (UseHotMenu)){
    var box = getBrowser().boxObject;
    MouseX = event.screenX - box.screenX + box.x;
    MouseY = event.screenY - box.screenY + box.y;

    document.popupNode = event.target;
    event.preventDefault();
    hotmenu();
  }
}

function hotmenu(){
try{
  var hotmenu = document.getElementById("cq-hotmenu");
  if (!hotmenu) {
    hotmenu = document.createElement("menupopup");
    hotmenu.id = "cq-hotmenu";
    document.documentElement.appendChild(hotmenu);
  }
  FillMenu();
  hotmenu.showPopup(getBrowser(), MouseX + 2, MouseY + 2, "context", "bottomleft", "topleft");
}catch(er){cqerr(er, "hotmenu sub")}
}
//EOf HotMenu

function FillMenu(evnt){
try{
	lastDirState = rdir(PlugsDir);
  getPageParams();
	if (srcupdated()) {
  	plg_QuickLoadAll();
  }
  prfs_UpdateEntries();

  var recommend = [];
  var ppMenu = document.getElementById("cq-ppm");
	if (Shift) {
    ppMenu = document.getElementById("cq-hotmenu");
  } else {
    ppMenu = document.getElementById("cq-ppm");
  }
	while (ppMenu.hasChildNodes()) {ppMenu.removeChild(ppMenu.lastChild)}
  var entries = EntryHash._Items();
  for (entry in entries){
    if (entries[entry].blocked) continue;
	  if (entries[entry].Context){
		  var ppItem = document.createElement("menuitem");
		  ppItem.setAttribute("label", entries[entry].Title);
		  ppItem.setAttribute("tooltiptext", "Hold Ctrl to tune it up");
		  ppItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entries[entry].eId+"')");
		  ppMenu.appendChild(ppItem);
		}else{
		  if (entries[entry].showif){
		    re = new RegExp(entries[entry].showif);
		    re.ignoreCase = true;
		    re.multiline = true;
		    if (re.test(PageSelection)) recommend[entry]="";
		  }
		}
  }
  if (recommend.length){
    ppMenu.appendChild(document.createElement("menuseparator"));
    for (each in recommend){
  	  var ppItem = document.createElement("menuitem");
  	  ppItem.setAttribute("label", entries[each].Title);
  	  ppItem.setAttribute("tooltiptext", "Hold Ctrl to tune it up");
  	  ppItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entries[each].eId+"')");
  	  ppMenu.appendChild(ppItem);
    }
  }
}catch(er){cqerr(er, "FillMenu sub")}
}

function ProcessEntry(ctrl, EntryId){
try{
	//getPageParams();
	var entry = EntryHash._Item(EntryId);
	if (ctrl) ShowAlternatives = true;
	//if plugin not loaded - load it
	if (!entry.Inputs){
		entry = ReadPluginData(entry.filepath);
    entry.Context = EntryHash[EntryId].Context;
		EntryHash._AddEntryObj(entry, entry.eId);
	}

  PrepareAction(entry.Inputs);
	if (cancel){
		resetenv();
		return;
	}

// Form it!
  var browser = getBrowser();
	tab = getBrowser().addTab("about:blank");
	oldTab = gBrowser.selectedTab;
	browser.selectedTab = tab;
  var doc = window._content.document;
  if (LoadTabsInBg) browser.selectedTab = oldTab;

  var frm = doc.createElement('form');
    
  frm.setAttribute("id", "cqrform");
  frm.setAttribute("action", entry.Action);
  frm.setAttribute("method", entry.Method);
  frm.setAttribute("accept-charset", entry.qcharset);
  for (each in QueryHash){
    var inp = doc.createElement("input");
      inp.setAttribute("type", "hidden");
      inp.setAttribute("name", each);
      inp.setAttribute("value", QueryHash[each]);
      frm.appendChild(inp);
  }
  doc.documentElement.appendChild(frm);
  frm.submit();
  resetenv();
}catch(er){cqerr(er, "ProcessEntry sub")}
}

function PrepareAction(lcInputObj){
try{
  for (i in lcInputObj){
    switch(lcInputObj[i].def.value){
      case "[:selection]":
        if (!PageSelection) ShowAlternatives=true;
        QueryHash[lcInputObj[i].def.name] = PageSelection;
        break;
      case "[:url]":
        QueryHash[lcInputObj[i].def.name] = PageURL;
        break;
      case "[:linkurl]":
        QueryHash[lcInputObj[i].def.name] = LinkURL;
        break;
      case "[:host]":
        QueryHash[lcInputObj[i].def.name] = PageHost;
        break;
      case "[:text]":
        QueryHash[lcInputObj[i].def.name] = "";
        break;
      case "[:prompt]":
        ShowAlternatives=true;
        QueryHash[lcInputObj[i].def.name] = "";
        break;
      default:
        QueryHash[lcInputObj[i].def.name] = lcInputObj[i].def.value;
    }
  }
  if (ShowAlternatives) window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", lcInputObj);
}catch(er){cqerr(er, "PrepareAction sub")}
}

function OpenCfgDialog(){
	window.openDialog("chrome://conquery/content/conquery-pref.xul", "ConQuery config",	"centerscreen,chrome,modal,resizable=yes");
  if (ConfigLastWillId){
    ProcessEntry(ConfigLastWillCtrl, ConfigLastWillId);
    ConfigLastWillId = "";
  }
}

function getPageParams(){
	try{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		PageSelection = String(focusedWindow.__proto__.getSelection.call(focusedWindow));
	}catch(er){PageSelection=""}
  
  try{
  	PageURL = focusedWindow.location.href;
	}catch(er){PageURL=""}
	
	try{
	  	PageHost = focusedWindow.location.host;
	}catch(er){PageHost=""}
}

function resetenv(){
	QueryHash = new Object();
	PageSelection = "";
	PageURL = "";
	PageHost = "";
	LinkURL = "";
	ConfigLastWillId = "";
	ConfigLastWillCtrl = false;
	ShowAlternatives = false;
	cancel = false;
}